density=function(M,v_out){
  # computes the density for the respective output vector v_out to be generated by M v_in /|| M v_in|| if v_in is chosen from the unit sphere
  dim = length(v_out)
  v_out = v_out/sqrt(sum(v_out^2))
  v_in = solve(M) %*% v_out
  stretch_factor = sqrt(sum(v_in^2)) 
  spectr = eigen(M)$values
  determinant = prod(spectr)
  return(1/(abs(determinant) * stretch_factor^dim))
}


test_density = function(){
  d = 10
  M = diag(1:d)
  prob = density(M,rnorm(d,0,1))
  cat('prob = ',prob,'\n')
  #M = diag(c(1,3))
  #p = rep(0,100)
  #angle = rep(0,100)
  #for (j in 1:100){
  #  angle[j] = j*2*pi/100
  #  v_out = c(cos(angle[j]),sin(angle[j]))
  #  p[j] = density(M,v_out)
  #}
  #plot(angle,p)
}

